//=========================================
// Name        : DualNumber_overloading.cpp
// Author      : JM
// Version     : niekompletna
// Copyright   : JM
// Description : Lab.ANiSS Zadanie 2.4*
//=========================================
#include <iostream>
#include <cstring>
#include <cmath>
using namespace std;

#define PI 3.141592653589793

class CDualNumber  {
  private:
      double m_real;
      double m_dual;
  public:
     CDualNumber (double real = 0.0, double dual = 0.0) :  m_real(real), m_dual(dual) {  }
    double Real () const { return m_real; }
    double Dual () const { return m_dual; }
};

//----------------------------------------------------------------------
// Operatory
//----------------------------------------------------------------------

inline CDualNumber operator + (const CDualNumber &a, const CDualNumber &b)  {
    return CDualNumber(a.Real() + b.Real(), a.Dual() + b.Dual());
}

inline CDualNumber operator - (const CDualNumber &a, const CDualNumber &b)  {
    return CDualNumber(a.Real() - b.Real(), a.Dual() - b.Dual());
}

inline CDualNumber operator / (const CDualNumber &a, const CDualNumber &b)  {
    return CDualNumber(a.Real() / b.Real(),
           (a.Dual() * b.Real() - a.Real() * b.Dual()) / (b.Real() * b.Real()) );
}

//----------------------------------------------------------------------
// Funkcje
//----------------------------------------------------------------------

inline CDualNumber sqrt (const CDualNumber &a)  {
	double sqrtReal;
    sqrtReal = std::sqrt(a.Real());
    return CDualNumber(sqrtReal, 0.5f * a.Dual() / sqrtReal );
}

inline CDualNumber pow (const CDualNumber &a, double y)  {
    return CDualNumber(std::pow(a.Real(), y),  y * a.Dual() * std::pow(a.Real(), y - 1.0f) );
}

inline CDualNumber sin (const CDualNumber &a)   {
    return CDualNumber( std::sin(a.Real()), a.Dual() * std::cos(a.Real()) );
}

inline CDualNumber atan (const CDualNumber &a)  {
    return CDualNumber(std::atan(a.Real()), a.Dual() / (1.0 + a.Real() * a.Real()) );
}

//----------------------------------------------------------------------
// Testy
//----------------------------------------------------------------------

CDualNumber Test(CDualNumber x) {
	return sin(x+1.0) - x;
}

//----------------------------------------------------------------------
// Main
//----------------------------------------------------------------------

int main (void) {
	CDualNumber f;
	double x = 1.25;
	f = Test(CDualNumber(x, 1.0));
        cout << "funkcja=" << f.Real() << ", pochodna=" << f.Dual() << endl;
	return 0;
}
